{-# OPTIONS_GHC  -XTypeSynonymInstances -XFlexibleInstances -XMultiParamTypeClasses  #-}

--------------------------------
-------Resource Aware ML--------
--------------------------------
-- File:
--   Monoid.hs
--
-- Author:
--   Jan Hoffmann (2011)
--
-- Description:
--   The resource monoid as described in our APLAS'10 paper.
--   The rational numbers in MonoidElem are assumed to be non-negative.

module Monoid where

import Prelude hiding ((.))



type MonoidElem = (Rational,Rational)

zero = 0 :: Rational

class ResMonoid a b where
  dot :: a -> b -> MonoidElem


instance ResMonoid MonoidElem MonoidElem where
  (q,q') `dot` (p,p') = if q' <= p then (q+p-q', p') else (q, p'+q'-p)

instance ResMonoid Rational MonoidElem where
  r `dot` (q,q') = if r >= 0 then (r,zero) `dot` (q,q') 
                   else (zero,-r) `dot` (q,q')

instance ResMonoid MonoidElem Rational where
  (q,q') `dot` r = if r >= 0 then (q,q')  `dot` (r,zero)
                   else  (q,q') `dot` (zero,-r)

instance ResMonoid Rational Rational where
  q `dot` r = if q >= 0 then (q,zero)  `dot` r
              else  (zero,-q) `dot` r